// "Zeitmaschine"
// Datumsnderung fr bestimmten Prozess
// Ideen: 1998 by c't / Matthias Withopf
// h#s 07/03

#if defined(__BORLANDC__)
#pragma option -a4  // DWORD-Alignment. Wichtig, sonst schlgt GetThreadContext
			// feht, wenn Context-Struktur nicht korrekt aligned ist.
#endif

#if defined(_MSC_VER)
#pragma auto_inline(off)
#pragma optimize("s",on)
#pragma comment(linker,"/OPT:NOWIN98 /NOD /RELEASE /LARGEADDRESSAWARE")
#pragma comment(linker,"/SUBSYSTEM:Windows /ENTRY:WinMainCRTStartup")
#endif

#include "iwatchsu.h"
#include "FakeHelp.h"
#include <commdlg.h>
#include <commctrl.h>
#include <shellapi.h>

HINSTANCE ghInstance = 0;
Boolean   IsWin95 = False;
Boolean   Inherit;	// = FALSE mittels GetPrivateProfileInt()
MYDATE MyDate;

void _cdecl Alert(PChar s,...) {
 TCHAR buf[1024];
 wvsprintf(buf,s,(va_list)(&s+1));
 MessageBox((HWND)0,buf,T("Zeitmaschine"),MB_OK | MB_ICONSTOP | MB_SETFOREGROUND);
}


Boolean GetDLLName(HANDLE hProcess,HANDLE hFile,LongWord BaseOfDll,
  Pointer ThreadLocalBase,LPTSTR DllName,int DllNameSize,PLongWord EntryPoint) {
 const int EntryPointOfs          = 0x28;
 const int ImageBaseOfs           = 0x34;
 const int ImageSecondHeaderOfs   = 0x3C;
 const int ImageExportTableRVAOfs = 0x78;
 if (!DllNameSize) return False;
 DllName[0] = '\0';
 if (EntryPoint) *EntryPoint = 0;
 Boolean NameOk = False;

  // Bestimme voll qualifizierten DLL-Namen;
  // undokumentierte Methode, von SDK-Tools abgeschaut
 if (!IsWin95 && ThreadLocalBase) {
  DWORD   Result;
  Pointer DLLNamePtr;
  if (ReadProcessMemory(hProcess,(PByte)ThreadLocalBase + 0x14,&DLLNamePtr,
    sizeof(DLLNamePtr),&Result) && (Result == sizeof DLLNamePtr))
  if (DLLNamePtr) {
   WCHAR tmp[256];
   if (ReadProcessMemory(hProcess,DLLNamePtr,tmp,sizeof(tmp),&Result)
   && (Result > 0)) {
#ifdef UNICODE
    lstrcpyn(DllName,tmp,DllNameSize);
#else
    WideCharToMultiByte(CP_ACP,0,tmp,-1,DllName,DllNameSize,0,NULL);
#endif
//    PWord p1 = tmp;
//    PChar p2 = DllName;
//    while (*p1 && (DllNameSize-- > 0)) *p2++ = (Char)*p1++;
//    *p2 = '\0';
    NameOk = True;
   }
  }
 }
 if (!hFile) return False;
 if (GetFileType(hFile) != FILE_TYPE_DISK) return False;
 if (SetFilePointer(hFile,0L,NULL,FILE_BEGIN) != 0) return False;
 WORD  DosSignature;
 DWORD dwNumberOfBytesRead = 0;
 if (!ReadFile(hFile,&DosSignature,sizeof DosSignature,&dwNumberOfBytesRead,NULL)) return False;
 if (DosSignature != IMAGE_DOS_SIGNATURE) return False;
 if (SetFilePointer(hFile,ImageSecondHeaderOfs,NULL,FILE_BEGIN) != ImageSecondHeaderOfs) return False;
 DWORD PeHeader;
 if (!ReadFile(hFile,&PeHeader,sizeof PeHeader,&dwNumberOfBytesRead,NULL)) return False;
 if (SetFilePointer(hFile,PeHeader,NULL,FILE_BEGIN) != PeHeader) return False;
 DWORD NtSignature;
 if (!ReadFile(hFile,&NtSignature,sizeof NtSignature,&dwNumberOfBytesRead,NULL)) return False;
 if (NtSignature != IMAGE_NT_SIGNATURE) return False;
 if (EntryPoint) {
  if (SetFilePointer(hFile,PeHeader + EntryPointOfs,NULL,FILE_BEGIN) != PeHeader + EntryPointOfs) return False;
  if (!ReadFile(hFile,EntryPoint,sizeof *EntryPoint,&dwNumberOfBytesRead,NULL)) return False;
  if (*EntryPoint) *EntryPoint += (LongWord)BaseOfDll;
 }
 if (NameOk) return True;
 if (SetFilePointer(hFile,PeHeader + ImageBaseOfs,NULL,FILE_BEGIN) != PeHeader + ImageBaseOfs) return False;
 DWORD ImageBase;
 if (!ReadFile(hFile,&ImageBase,sizeof(ImageBase),&dwNumberOfBytesRead,NULL)) return False;
 if (SetFilePointer(hFile,PeHeader + ImageExportTableRVAOfs,NULL,FILE_BEGIN) != PeHeader + ImageExportTableRVAOfs) return False;
 IMAGE_DATA_DIRECTORY ExportTable;
 if (!ReadFile(hFile,&ExportTable,sizeof ExportTable,&dwNumberOfBytesRead,NULL)) return False;
 if (ExportTable.VirtualAddress && ExportTable.Size) {
  PByte ET = new Byte[ExportTable.Size];
  if (!ET) return False;
  if (!ReadProcessMemory(hProcess,(LPVOID)(BaseOfDll + ExportTable.VirtualAddress),ET,ExportTable.Size,&dwNumberOfBytesRead)) return False;
  IMAGE_EXPORT_DIRECTORY *E = (IMAGE_EXPORT_DIRECTORY *)ET;
  StrCopy(DllName,(LPCTSTR)ET + E->Name - ExportTable.VirtualAddress,DllNameSize);
  if (ET) delete [] ET;
 }else StrCopy(DllName,T("???"),DllNameSize);
 return True;
}

////////////////////////////////////////////////////////////////////////////////

#if defined(CPU_INTEL)
typedef Byte     TBreakpointType;
TBreakpointType  BreakpointInstr = 0xcc;         // INT 3
#elif defined(CPU_ALPHA)
typedef LongWord TBreakpointType;
TBreakpointType  BreakpointInstr = 0x00000080;   // CALLPAL BPT
#endif

typedef struct {
 LongWord de_BaseAddr;
 LongWord de_EntryAddr;
 Boolean  de_Patched;
} TDllEntry,* PDllEntry;

typedef struct {
 DWORD  te_ThreadId;
 HANDLE te_ThreadHandle;
} TThreadEntry,* PThreadEntry;

typedef struct {
 Pointer         dse_CodeStart;
 CONTEXT         dse_Context;
 TBreakpointType dse_EntryCode;
} TDllStartEntry;

class TProcessWatcher {
public:
 TProcessWatcher(PChar AExtensionDllName);
 Boolean Run(LPCTSTR AppName, LPCTSTR CmdLine,int *ReturnCode);
 private:
 DWORD FirstProcessId;	// zum Beenden der Debug-Hauptschleife
  PChar				ExtensionDllName;
  LongWord			ExtensionDllBase;
  LongWord			ExtensionDllInitFunc;
  LongWord			ExtensionStack;
  STARTUPINFO			StartupInfo;
  PROCESS_INFORMATION		ProcessInfo;
  CREATE_PROCESS_DEBUG_INFO	ProcessDebugInfo;
  typedef enum {
   ps_Unknown,
   ps_FirstBreak,
   ps_PatchProcess,
   ps_PatchStaticDlls,
   ps_ProcessComplete,
   ps_PatchDynamicDll,
   ps_PatchDynamicDllNoInit,
  } TProcessState;
  TProcessState			ProcessState;
  Boolean			ProcessPatchedDone;
  CONTEXT			Context1;
  enum { CodeFragmentSize = 512 };
  BYTE	OrigCodeFragment[CodeFragmentSize],MyCodeFragment[CodeFragmentSize];
  DWORD	NewCodeSize;
  TBreakpointType		OrigCodeStart;
  Pointer			CodeFragmentAddr;
  enum { MaxNestedDllCount = 32 };
  TDllStartEntry		DllEntryTab[MaxNestedDllCount];
  Pointer			LastDllEntryBreakAddr;
  enum { MaxDllCount = 256 };
  TDllEntry			DllTab[MaxDllCount];
  enum { MaxThreadCount = 1024 };
  TThreadEntry			ThreadTab[MaxThreadCount];
  Boolean SetStartBreak(void);
  Boolean PatchProcess(void);
  Boolean PatchDll(LongWord DllBaseAddr,HANDLE ThreadHandle);
  Boolean ProcessPatched(void);
  Boolean RestoreProcess(Boolean f,HANDLE ThreadHandle,Boolean ResetContext);
  Boolean AddDll(LongWord BaseAddr,LongWord EntryAddr);
  Boolean RemoveDll(LongWord BaseAddr);
  Boolean PatchDlls(HANDLE ThreadHandle,Boolean ASuspendThreads,Pointer DllEntryAddr);
  Boolean AddThread(DWORD ThreadId,HANDLE ThreadHandle);
  Boolean RemoveThread(DWORD ThreadId);
  void    SuspendThreads(HANDLE ThreadHandle);
  void    ResumeThreads(HANDLE ThreadHandle);
  HANDLE  ThreadId2Handle(DWORD ThreadId);
  DWORD   HandleDebugEvent(LPDEBUG_EVENT Event);
  Boolean PatchDllEntry(Pointer DllEntryPoint);
  Boolean RestoreDllEntry(HANDLE ThreadHandle,Pointer BreakAddr,PBoolean MoreBPs);
  Boolean IsDllEntryBreak(HANDLE ThreadHandle,Pointer BreakAddr);
 };
typedef TProcessWatcher * PProcessWatcher;

TProcessWatcher::TProcessWatcher(PChar AExtensionDllName) {
 MemSet(this,0,sizeof(TProcessWatcher));
 ExtensionDllName     = AExtensionDllName;
// ExtensionDllBase     = 0;
// ExtensionDllInitFunc = 0;
// ExtensionStack       = 0;
// InitStruct(&StartupInfo,sizeof StartupInfo);
 StartupInfo.cb=sizeof(StartupInfo);
// MemSet(&ProcessInfo,0,sizeof ProcessInfo);
// MemSet(&ProcessDebugInfo,0,sizeof ProcessDebugInfo);
// ProcessState         = ps_FirstBreak;
// ProcessPatchedDone   = False;
// NewCodeSize          = 0;
// MemSet(DllEntryTab,0,sizeof DllEntryTab);
// LastDllEntryBreakAddr = NULL;
// MemSet(DllTab,0,sizeof(DllTab));
// MemSet(ThreadTab,0,sizeof(ThreadTab));
}

Boolean TProcessWatcher::SetStartBreak(void) {
 const int EntryPointOfs        = 0x28;
 const int ImageSecondHeaderOfs = 0x3C;
 CodeFragmentAddr = ProcessDebugInfo.lpStartAddress;
 if (!CodeFragmentAddr) {
      // Process wurde attached.
  PByte    ProcessBase = (PByte)ProcessDebugInfo.lpBaseOfImage;
  DWORD    Result;
  LongWord PEOfs;
  BOOL f = ReadProcessMemory(ProcessInfo.hProcess,ProcessBase + ImageSecondHeaderOfs,&PEOfs,sizeof PEOfs,&Result);
  if (!f || Result!=sizeof PEOfs) return False;
  LongWord EntryRVA;
  f = ReadProcessMemory(ProcessInfo.hProcess,ProcessBase + PEOfs + EntryPointOfs,&EntryRVA,sizeof EntryRVA,&Result);
  if (!f || Result!=sizeof EntryRVA) return False;
  ProcessDebugInfo.lpStartAddress = (LPTHREAD_START_ROUTINE)(ProcessBase + EntryRVA);
  CodeFragmentAddr = ProcessDebugInfo.lpStartAddress;
  if (!CodeFragmentAddr) return False;
 }

  // originales Code-Fragment sichern
 DWORD Result;
 BOOL f = ReadProcessMemory(ProcessInfo.hProcess,CodeFragmentAddr,&OrigCodeStart,sizeof(OrigCodeStart),&Result);
 if (!f || (Result != sizeof OrigCodeStart)) return False;
      // neues Code-Fragment in laufenden Proze patchen
 f = WriteProcessMemory(ProcessInfo.hProcess,CodeFragmentAddr,&BreakpointInstr,sizeof(BreakpointInstr),&Result);
 if (!f || (Result != sizeof BreakpointInstr)) {
  Alert(T("Couldn't patch!!!\n"));
  return False; 
 }
 FlushInstructionCache(ProcessInfo.hProcess,CodeFragmentAddr,sizeof BreakpointInstr);
 return True;
}

Boolean TProcessWatcher::PatchProcess(void) {
 HMODULE KernelModule=GetModuleHandle(T("KERNEL32.DLL"));
 if (!KernelModule) return False;
 FARPROC LoadLibraryProc=GetProcAddress(KernelModule,
#ifdef UNICODE
							"LoadLibraryW");
#else
							"LoadLibraryA");
#endif
 if (!LoadLibraryProc) return False;
 FARPROC GetLastErrorProc=GetProcAddress(KernelModule,"GetLastError");
 if (!GetLastErrorProc) return False;
 FARPROC GetProcAddressProc=GetProcAddress(KernelModule,"GetProcAddress");
 if (!GetProcAddressProc) return False;
 CodeFragmentAddr=ProcessDebugInfo.lpStartAddress;
 if (!CodeFragmentAddr) return False;

 Context1.ContextFlags=CONTEXT_FULL;
 if (!GetThreadContext(ProcessInfo.hThread,&Context1)) return False;

  // originales Code-Fragment sichern
 DWORD Result;
 BOOL f = ReadProcessMemory(ProcessInfo.hProcess,CodeFragmentAddr,OrigCodeFragment,sizeof(OrigCodeFragment),&Result);
 if (!f || Result!=sizeof(OrigCodeFragment)) return False;
 MemCpy(OrigCodeFragment,&OrigCodeStart,sizeof(OrigCodeStart));

 // neues Code-Fragment in laufenden Proze patchen
 PDWORD p=(PDWORD)MyCodeFragment;
#if defined(CPU_INTEL)
 *((PBYTE&)p)++=0x68;	     // PUSH	L_DllName	; Zeiger auf DLL-Dateinamen
 *	   p ++=(DWORD)CodeFragmentAddr+0x40;		// 0x40 = Lnge dieses Code-Schnipsels
 *((PBYTE&)p)++=0xE8;	     // CALL	LoadLibraryA
 *         p ++=(DWORD)LoadLibraryProc-(DWORD)CodeFragmentAddr-(int)((PBYTE)p-MyCodeFragment)-4;
 *	   p ++=0x0875C009;
//		09 C0		OR	EAX,EAX		; konnte DLL geladen werden ?
//		75 08		JNZ	L_Ok		; ja -> EAX enthlt HMODULE
 *((PBYTE&)p)++=0xE8;	     // CALL	GetLastError
 *         p ++=(DWORD)GetLastErrorProc-(DWORD)CodeFragmentAddr-(int)((PBYTE)p-MyCodeFragment)-4;
 *	   p ++=0x96CC01B3;
//		B3 01		MOV	BL,1		; BL = 1 (Fehler beim Laden)
//		CC		INT	3		; Breakpoint
//		96		XCHG	ESI,EAX		; rette HMODULE in ESI
 *	   p ++=0xE856026A;
//		6A 02		PUSH	2		; _init-Ordinal
//		56		PUSH	ESI
//		E8		CALL	GetProcAddress
 *	   p ++=(DWORD)GetProcAddressProc-(DWORD)CodeFragmentAddr-(int)((PBYTE)p-MyCodeFragment)-4;
 *         p ++=0x0375C009;
//		09 C0		OR	EAX,EAX		; konnte Funktion gefunden werden ?
//		75 03		JNZ	L_Ok1		; ja -> EAX enthlt Adresse
 *         p ++=0x97CC02B3;
//		B3 02		MOV	BL,2		; BL = 2 (Fehler beim Ermitteln der Startfunktion)
//		CC		INT	3		; Breakpoint
//		97		XCHG	EDI,EAX		; rette Funktionsadresse
 *((PBYTE&)p)++=0x68;	     // PUSH	xxxxxxxx	; bergebe Zeit
 *	   p ++=MyDate.all;
 *((PBYTE&)p)++=0x6A;	     // PUSH	iwa_SetTime
 *((PBYTE&)p)++=(BYTE)iwa_SetTime;
 *	   p ++=0x6A56D7FF;
 *	   p ++=0x50D7FF01;
//		FF D7		CALL	EDI		; rufe Funktion auf
//		56		PUSH	ESI		; bergebe DLL-Basisadresse
//		6A 01		PUSH	1		; iwa_SetDllBase
//		FF D7		CALL	EDI		; rufe Funktion auf
//		50		PUSH	EAX		; Zeiger auf eigenen Stackbereich retten
 *((PBYTE&)p)++=0x6A;	     // PUSH	0		; bergebe Module-Adresse
 *((PBYTE&)p)++=0x00;
 *	   p ++=0xD7FF026A;
//		6A 02		PUSH	2		; iwa_PatchFunctions
//		FF D7		CALL EDI		; rufe Funktion auf
 *	   p ++=0xCC59DB31;
//		31 DB		XOR	EBX,EBX		; BL = 0 (Laden ok)
//		59		POP	ECX		; Zeiger auf eigenen Stackbereich
//		CC		INT	3		; Breakpoint
#elif defined(CPU_ALPHA)
 LongWord InitFuncOfs = 2;	// kein Offset!
 LongWord DLLNameOfs  = (LongWord)CodeFragmentAddr + 35 * sizeof(DWORD);
 LongWord LoadLibFunc = (LongWord)LoadLibraryProc;
 LongWord GetProcFunc = (LongWord)GetProcAddressProc;
 LongWord GetErrFunc  = (LongWord)GetLastErrorProc;
 LongWord ProcessId   = (LongWord)GetCurrentProcessId();
 *p++=0x221F0000|(Word)DLLNameOfs;			// LDA	A0,xxxx(ZERO)	; lese Zeiger auf DLL-Namen in A0
 *p++=0x26100000|(Word)((DLLNameOfs+0x8000)>>16);	// LDAH	A0,xxxx(A0)
 *p++=0x201F0000|(Word)LoadLibFunc;			// LDA	V0,xxxx(ZERO)	; lese Funktionsadresse von LoadLibraryA()
 *p++=0x24000000|(Word)((LoadLibFunc+0x8000)>>16);	// LDAH	V0,xxxx(V0)
 *p++=0x6B404000;					// JSR	RA,(V0),0	; LoadLibraryA() aufrufen
 *p++=0xF4000005;					// BNE	V0,L_Ok		; falls ok -> weiter
 *p++=0x201F0000|(Word)GetErrFunc;			// LDA	V0,xxxx(ZERO)	; lese Funktionsadresse von GetLastError()
 *p++=0x24000000|(Word)((GetErrFunc+0x8000)>>16);	// LDAH	V0,xxxx(V0)
 *p++=0x6B404000;					// JSR	RA,(V0),0	; GetLastError() aufrufen
 *p++=0x213F0001;					// MOV	1,S0		; S0 = 1 (Fehler beim Laden)
 *p++=0x00000080;					// CALLPAL BPT		; Breakpoint
 *p++=0x4400040A;					// MOV	V0,S1		; rette HMODULE in S1
 *p++=0x44000410;					// MOV	V0,A0		; HMODULE als 1. Argument
 *p++=0x223F0000|(Word)InitFuncOfs;			// LDA	A1,xxxx(ZERO)	; lese Zeiger auf '_Init'
 *p++=0x26310000|(Word)((InitFuncOfs+0x8000)>>16);	// LDAH	A1,xxxx(A1)	; als 2. Argument
 *p++=0x201F0000|(Word)GetProcFunc;			// LDA	V0,xxxx(ZERO)	; lese Funktionsadresse von GetProcAddressProc()
 *p++=0x24000000|(Word)((GetProcFunc+0x8000)>>16);	// LDAH	V0,xxxx(V0)
 *p++=0x6B404000;					// JSR	RA,(V0),0	; GetProcAddressProc() aufrufen
 *p++=0xF4000002;					// BNE	V0,L_Ok1	; falls ok -> weiter
 *p++=0x213F0002;					// MOV	2,S0		; S0 = 2 (Fehler beim Ermitteln der Startfunktion)
 *p++=0x00000080;					// CALLPAL BPT		; Breakpoint
 *p++=0x4400040B;					// MOV	V0,S2		; rette Funktionsadresse in S2
 *p++=0x221F0000|iwa_SetTime;				// MOV	3,A0		; iwa_SetProcessId als 1. Argument
 *p++=0x223F0000|(Word)MyDate.all;			// LDA	A1,xxxx(ZERO)	; GetCurrentProcessId()
 *p++=0x26310000|(Word)((MyDate.all+0x8000)>>16);	// LDAH	A1,xxxx(A1)	; als 2. Argument
 *p++=0x6B4B4000;					// JSR	RA,(S2),0	; _Init() aufrufen
 *p++=0x221F0000|iwa_SetDllBase;			// MOV	1,A0		; iwa_SetDllBase als 1. Argument
 *p++=0x454A0411;					// MOV	S1,A1		; DLL-Basisadresse als 2. Argument
 *p++=0x6B4B4000;					// JSR	RA,(S2),0	; _Init() aufrufen
 *p++=0x4400040C;					// MOV	V0,S3		; rette Zeiger auf eigenen Stackbereich in S3
 *p++=0x221F0000|iwa_PatchFunctions;			// MOV	2,A0		; iwa_PatchFunctions als 1. Argument
 *p++=0x223F0000;					// MOV	0,A1
 *p++=0x6B4B4000;					// JSR	RA,(S2),0	; _Init() aufrufen
 *p++=0x213F0000;					// MOV	0,S0		; S0 = 0 (Laden ok)
 *p++=0x00000080;					// CALLPAL BPT		; Breakpoint
#endif
  DWORD l=StrLen(ExtensionDllName)+1;
  MemCpy(p,ExtensionDllName,l);       // DB   "...",0         ; DLL-Name
  (PBYTE*&)p+=l;
  NewCodeSize=(DWORD)((PBYTE)p-MyCodeFragment);
  f=WriteProcessMemory(ProcessInfo.hProcess,CodeFragmentAddr,&MyCodeFragment,NewCodeSize,&Result);
  if (!f || Result!=NewCodeSize) {
   Alert(T("Couldn't patch!!!\n")); 
   return False; 
  }
  FlushInstructionCache(ProcessInfo.hProcess,CodeFragmentAddr,NewCodeSize);
  CONTEXT Context2 = Context1;
#if defined(CPU_INTEL)
  Context2.Eip = (DWORD)CodeFragmentAddr;
#elif defined(CPU_ALPHA)
  Context2.Fir = (DWORDLONG)CodeFragmentAddr;
#endif
  if (!SetThreadContext(ProcessInfo.hThread,&Context2)) {
   Alert(T("SetThreadContext() failed!\n")); 
   return False; 
  }
  return True;
}

Boolean TProcessWatcher::PatchDll(LongWord DllBaseAddr,HANDLE ThreadHandle) {
  // neues Code-Fragment in laufenden Proze patchen
 PDWORD p =(PDWORD)MyCodeFragment;
#if defined(CPU_INTEL)
 *((PBYTE&)p)++=0x68;	     // PUSH	xxxxxxxx	; bergebe Dll-Basisadresse
 *	   p ++=DllBaseAddr;
 *	   p ++ = 0xD7FF026A;
//		6A 02		PUSH	2		; iwa_PatchFunctions
//		FF D7		CALL	EDI		; rufe Funktion auf
 *((PBYTE&)p)++=0xCC;	     // INT	3		; Breakpoint
#elif defined(CPU_ALPHA)
 *p++=0x221F0000|iwa_PatchFunctions;			// MOV	3,A0		; iwa_PatchFunctions als 1. Argument
 *p++=0x223F0000|(Word)DllBaseAddr;			// LDA	A1,xxxx(ZERO)	; DllBaseAddr
 *p++=0x26310000|(Word)((DllBaseAddr+0x8000)>>16);	// LDAH	A1,xxxx(A1)	; als 2. Argument
 *p++=0x6B4B4000;					// JSR	RA,(S2),0	; _Init() aufrufen
 *p++=0x00000080;					// CALLPAL BPT
#endif
 DWORD CodeSize = (DWORD)((PBYTE)p - MyCodeFragment);
 DWORD Result;
 BOOL f = WriteProcessMemory(ProcessInfo.hProcess,CodeFragmentAddr,&MyCodeFragment,CodeSize,&Result);
 if (!f || Result!=CodeSize) { 
  Alert(T("Couldn't patch!!!\n")); 
  return False; 
 }
 FlushInstructionCache(ProcessInfo.hProcess,CodeFragmentAddr,CodeSize);
 CONTEXT Context2 = Context1;
#if defined(CPU_INTEL)
 Context2.Edi    = ExtensionDllInitFunc;
 Context2.Ebp    = 0;
 Context2.Esp    = ExtensionStack;
 Context2.Eip    = (DWORD)CodeFragmentAddr;
 Context2.EFlags = 0x0216;
#elif defined(CPU_ALPHA)
 Context2.IntS2 = (DWORDLONG)ExtensionDllInitFunc;
 Context2.IntSp = (DWORDLONG)ExtensionStack;
 Context2.Fir   = (DWORDLONG)CodeFragmentAddr;
#endif
 if (!SetThreadContext(ThreadHandle,&Context2)) { 
  Alert(T("SetThreadContext() failed!\n")); 
  return False; 
 }
 return True;
}

Boolean TProcessWatcher::ProcessPatched(void) {
 if (ProcessPatchedDone) return True;
 ProcessPatchedDone = True;
 CONTEXT C;
 C.ContextFlags = CONTEXT_FULL;
 if (!GetThreadContext(ProcessInfo.hThread,&C)) {
  Alert(T("GetThreadContext failed!\n")); 
  return False;
 }
#if defined(CPU_INTEL)
 if (C.Ebx & 255) {
//  printf(T("Error loading '%s', error code = %08lX\n"),ExtensionDllName,C.Ebx);
//  printf(T("EIP: %08lX\n"),C.Eip);
//  printf(T("EAX: %08lX\n"),C.Eax);    // Rckgabewert von _Init()
//  printf(T("EBX: %08lX\n"),C.Ebx);    // Fehlercode, 0 = ok
//  printf(T("ESI: %08lX\n"),C.Esi);    // DLL-Basisadresse
//  printf(T("EDI: %08lX\n"),C.Edi);    // Adresse von _Init()
 }
 ExtensionDllBase     = C.Esi;
 ExtensionDllInitFunc = C.Edi;
 ExtensionStack       = C.Ecx;
#elif defined(CPU_ALPHA)
 if (C.IntS0) {
// TCHAR tmp[256];
  printf(T("Error loading '%s', error code = %08lX\n"),ExtensionDllName,C.IntS0);
  printf(T("FIR: %08lX\n"),C.Fir);
  printf(T("V0:  %08lX\n"),C.IntV0);	// Rckgabewert von _Init()
  printf(T("S0:  %08lX\n"),C.IntS0);	// Fehlercode, 0 = ok
  printf(T("S1:  %08lX\n"),C.IntS1);	// DLL-Basisadresse
  printf(T("S2:  %08lX\n"),C.IntS2);	// Adresse von _Init()
 }
 ExtensionDllBase     = (LongWord)C.IntS1;
 ExtensionDllInitFunc = (LongWord)C.IntS2;
 ExtensionStack       = (LongWord)C.IntS3;
#endif
 return True;
}

Boolean TProcessWatcher::RestoreProcess(Boolean f,HANDLE ThreadHandle,Boolean ResetContext) {
 DWORD Result;
 BOOL f1 = WriteProcessMemory(ProcessInfo.hProcess,CodeFragmentAddr,OrigCodeFragment,NewCodeSize,&Result);
 if (!f1 || Result!=NewCodeSize) return False;
 FlushInstructionCache(ProcessInfo.hProcess,CodeFragmentAddr,NewCodeSize);
 if (ResetContext) {
  if (f)
#if defined(CPU_INTEL)
  Context1.Eip = (DWORD)CodeFragmentAddr;
#elif defined(CPU_ALPHA)
  Context1.Fir = (DWORDLONG)CodeFragmentAddr;
#endif
  if (!SetThreadContext(ThreadHandle,&Context1)) { 
   Alert(T("SetThreadContext() failed!\n")); 
   return False; 
  }
 }
 return True;
}

Boolean TProcessWatcher::AddDll(LongWord BaseAddr,LongWord EntryAddr) {
 if (!BaseAddr) return False;
 for (int i=0;i<MaxDllCount;++i) if (DllTab[i].de_BaseAddr == BaseAddr) return True;
 for (i=0;i<MaxDllCount;++i) if (!DllTab[i].de_BaseAddr) {
//  MemSet(&DllTab[i],0,sizeof DllTab[i]);
  DllTab[i].de_BaseAddr  = BaseAddr;
  DllTab[i].de_EntryAddr = EntryAddr;
  return True;
 }
 return False;
}

Boolean TProcessWatcher::RemoveDll(LongWord BaseAddr) {
 if (!BaseAddr) return False;
 for (int i=0;i < MaxDllCount;++i) if (DllTab[i].de_BaseAddr == BaseAddr) {
  MemSet(&DllTab[i],0,sizeof(DllTab[i]));
  return True;
 }
 return False;
}

Boolean TProcessWatcher::PatchDlls(HANDLE ThreadHandle,Boolean ASuspendThreads,Pointer DllEntryAddr) {
 LongWord BaseAddr;
 for (int i = 0;i < MaxDllCount;++i) if (BaseAddr=DllTab[i].de_BaseAddr) if (!DllTab[i].de_Patched) {
  if (DllEntryAddr && DllEntryAddr!=(Pointer)BaseAddr && DllEntryAddr!=(Pointer)DllTab[i].de_EntryAddr)
    continue;
  if (IsWin95 && BaseAddr>=0x80000000) continue;
  if (BaseAddr==ExtensionDllBase) continue;
//          if (Verbose) { Char tmp[80]; wsprintf((Pchar)tmp,(Pchar)"Patching Dll at %08lX\n",BaseAddr); Write(tmp); }
  DllTab[i].de_Patched = True;
  PatchDll(BaseAddr,ThreadHandle);
  if (ASuspendThreads) SuspendThreads(ThreadHandle);
  return True;
 }
 return False;
}

Boolean TProcessWatcher::AddThread(DWORD ThreadId,HANDLE ThreadHandle) {
 for (int i = 0;i < MaxThreadCount;++i) if (ThreadTab[i].te_ThreadId == ThreadId) return True;
 for (i = 0;i < MaxThreadCount;++i) if (!ThreadTab[i].te_ThreadId) {
//  MemSet(&ThreadTab[i],0,sizeof ThreadTab[i]);
  ThreadTab[i].te_ThreadId     = ThreadId;
  ThreadTab[i].te_ThreadHandle = ThreadHandle;
  return True;
 }
 return False;
}

Boolean TProcessWatcher::RemoveThread(DWORD ThreadId) {
 for (int i = 0;i < MaxThreadCount;++i) if (ThreadTab[i].te_ThreadId == ThreadId) {
  MemSet(&ThreadTab[i],0,sizeof ThreadTab[i]);
  return True;
 }
 return False;
}

void TProcessWatcher::SuspendThreads(HANDLE ThreadHandle) {
 HANDLE T;
 for (int i = 0;i < MaxThreadCount;++i)
 if ((T = ThreadTab[i].te_ThreadHandle) != ThreadHandle)
 if (T) {
//          if (Verbose) { Char tmp[80]; wsprintf((Pchar)tmp,(Pchar)"Suspending thread %lX\n",T); Write(tmp); }
  SuspendThread(T);
 }
}

void TProcessWatcher::ResumeThreads(HANDLE ThreadHandle) {
 HANDLE T;
 for (int i = 0;i < MaxThreadCount;++i)
 if ((T = ThreadTab[i].te_ThreadHandle) != ThreadHandle)
 if (T) {
//          if (Verbose) { Char tmp[80]; wsprintf((Pchar)tmp,(Pchar)"Resuming thread %lX\n",T); Write(tmp); }
  ResumeThread(T);
 }
}

HANDLE TProcessWatcher::ThreadId2Handle(DWORD ThreadId) {
 for (int i = 0;i < MaxThreadCount;++i)
 if (ThreadTab[i].te_ThreadId == ThreadId)
 return ThreadTab[i].te_ThreadHandle;
 return 0;
}

Boolean TProcessWatcher::PatchDllEntry(Pointer DllEntryPoint) {
 Boolean Result = True;
 Boolean Ok     = False;
 int i;
 for (i = 0;i < MaxNestedDllCount;++i) if (!DllEntryTab[i].dse_CodeStart) {
  Ok = True;
  break;
 }
 if (!Ok) return False;
 MemSet(&DllEntryTab[i],0,sizeof DllEntryTab[i]);
 DllEntryTab[i].dse_CodeStart = (Pointer)DllEntryPoint;
 DWORD ResultSize;
 BOOL f = ReadProcessMemory(ProcessInfo.hProcess,(Pointer)DllEntryPoint,&DllEntryTab[i].dse_EntryCode,sizeof DllEntryTab[i].dse_EntryCode,&ResultSize);
 if (!f || (ResultSize != sizeof DllEntryTab[i].dse_EntryCode)) {
  Result = False;
  Alert(T("Couldn't read code to patch!!!\n"));
 }
 f = WriteProcessMemory(ProcessInfo.hProcess,(Pointer)DllEntryPoint,&BreakpointInstr,sizeof BreakpointInstr,&ResultSize);
 if (!f || (ResultSize != sizeof BreakpointInstr)) {
  Result = False;
  Alert(T("Couldn't patch!!!\n")); 
 }
 FlushInstructionCache(ProcessInfo.hProcess,(Pointer)DllEntryPoint,sizeof BreakpointInstr);
 return Result;
}

Boolean TProcessWatcher::RestoreDllEntry(HANDLE ThreadHandle,Pointer BreakAddr,PBoolean MoreBPs) {
 Boolean  Result    = True;
 LongWord CodeDelta = 64;
 int i;
 for (i = 0;i < MaxNestedDllCount;++i)
 if (((LongWord)BreakAddr - (LongWord)DllEntryTab[i].dse_CodeStart) < CodeDelta) {
  DWORD ResultSize;
  BOOL f = WriteProcessMemory(ProcessInfo.hProcess,DllEntryTab[i].dse_CodeStart,&DllEntryTab[i].dse_EntryCode,sizeof DllEntryTab[i].dse_EntryCode,&ResultSize);
  if (!f || (ResultSize != sizeof DllEntryTab[i].dse_EntryCode)) {
   Result = False;
   Alert(T("Couldn't patch!!!\n"));
  }
  FlushInstructionCache(ProcessInfo.hProcess,DllEntryTab[i].dse_CodeStart,sizeof DllEntryTab[i].dse_EntryCode);
  if (!SetThreadContext(ThreadHandle,&DllEntryTab[i].dse_Context)) {
   Alert(T("SetThreadContext() failed!\n")); 
   return False; 
  }
  MemSet(&DllEntryTab[i],0,sizeof DllEntryTab[i]);
  break;
 }
  // stehen noch weitere Breakpoints von DllEntries aus?
 if (MoreBPs) for (i = 0;i < MaxNestedDllCount;++i) if (DllEntryTab[i].dse_CodeStart) {
  *MoreBPs = True;
  break;
 }
 return Result;
}

Boolean TProcessWatcher::IsDllEntryBreak(HANDLE ThreadHandle,Pointer BreakAddr) {
 for (int i=0;i<MaxNestedDllCount;++i) if (DllEntryTab[i].dse_CodeStart == BreakAddr) {
  DllEntryTab[i].dse_Context.ContextFlags=
#if defined(CPU_INTEL)
					  CONTEXT_FULL|CONTEXT_FLOATING_POINT;
#elif defined(CPU_ALPHA)
					  CONTEXT_FULL;
#endif
  GetThreadContext(ThreadHandle,&DllEntryTab[i].dse_Context);
#if defined(CPU_INTEL)
  --DllEntryTab[i].dse_Context.Eip;
#endif
  LastDllEntryBreakAddr = BreakAddr;
  return True;
 }
 return False;
}

DWORD TProcessWatcher::HandleDebugEvent(LPDEBUG_EVENT Event) {
 if (Event->dwDebugEventCode==CREATE_PROCESS_DEBUG_EVENT)  {
  ProcessInfo.dwProcessId = Event->dwProcessId;     // Process wurde attached
  ProcessInfo.dwThreadId  = Event->dwThreadId;
  ProcessInfo.hProcess    = Event->u.CreateProcessInfo.hProcess;
  ProcessInfo.hThread     = Event->u.CreateProcessInfo.hThread;
  if (!FirstProcessId) FirstProcessId=ProcessInfo.dwProcessId;
 }
 HANDLE ThreadHandle = ThreadId2Handle(Event->dwThreadId);
 TCHAR DllName[MAX_PATH]={T('\0')};
 LongWord DllEntryPoint = 0;
 if (Event->dwDebugEventCode == LOAD_DLL_DEBUG_EVENT) {
  if (!GetDLLName(ProcessInfo.hProcess,Event->u.LoadDll.hFile,(DWORD)Event->u.LoadDll.lpBaseOfDll,
    ProcessDebugInfo.lpThreadLocalBase,DllName,elemof(DllName),&DllEntryPoint))
   DllName[0] = T('\0');
 }
 switch (Event->dwDebugEventCode) {
  case CREATE_PROCESS_DEBUG_EVENT: {
   ProcessState=ps_FirstBreak;
   ProcessDebugInfo=Event->u.CreateProcessInfo;
   AddThread(Event->dwThreadId,Event->u.CreateProcessInfo.hThread);
  }break;

  case CREATE_THREAD_DEBUG_EVENT: {
   AddThread(Event->dwThreadId,Event->u.CreateThread.hThread);
  }break;

  case EXIT_THREAD_DEBUG_EVENT: {
   RemoveThread(Event->dwThreadId);
  }break;

  case EXCEPTION_DEBUG_EVENT: {
   if (Event->u.Exception.ExceptionRecord.ExceptionCode == EXCEPTION_BREAKPOINT) {
    switch (ProcessState) {
     case ps_FirstBreak: {
      ProcessState = ps_PatchProcess;		// ++
      SetStartBreak();		// vermutlich um Stack initialisieren zu lassen?
#if defined(CPU_ALPHA)
     }break;
#else
     }return DBG_CONTINUE;
#endif

     case ps_PatchProcess: {
      ProcessState = ps_PatchStaticDlls;	// ++
      PatchProcess();
     }return DBG_CONTINUE;

     case ps_PatchStaticDlls: {
      ProcessPatched();
      if (!PatchDlls(ProcessInfo.hThread,False,NULL)) {
       RestoreProcess(True,ProcessInfo.hThread,True);
       ProcessState = ps_ProcessComplete;	// ++
      }
     }return DBG_CONTINUE;

     case ps_ProcessComplete: break;

     case ps_PatchDynamicDll: {
                  // prfe, ob Breakpoint von DllEntry oder von CodeFragment kommt
      if (IsDllEntryBreak(ThreadHandle,Event->u.Exception.ExceptionRecord.ExceptionAddress)) {
                      // Context wurde gesichert
       PatchDlls(ThreadHandle,False,Event->u.Exception.ExceptionRecord.ExceptionAddress);
      }else{
       Boolean MoreBPs;
       RestoreDllEntry(ThreadHandle,LastDllEntryBreakAddr,&MoreBPs);
       RestoreProcess(False,ThreadHandle,False);
       ResumeThreads(ThreadHandle);
       if (!MoreBPs) ProcessState = ps_ProcessComplete;
      }
     }return DBG_CONTINUE;

     case ps_PatchDynamicDllNoInit: {
      RestoreProcess(False,ThreadHandle,True);
      ResumeThreads(ThreadHandle);
      ProcessState = ps_PatchDynamicDll;
     }return DBG_CONTINUE;
    }/*switch*/
   }/*if*/
#if defined(CPU_ALPHA)
   {
    CONTEXT C;
    C.ContextFlags = CONTEXT_FULL;
    if (GetThreadContext(ThreadHandle,&C)) {
     C.Fir += sizeof(DWORD);             // Breakpoint-Instruktion berspringen
     SetThreadContext(ThreadHandle,&C);
    }
   }
  }return DBG_CONTINUE;
#else
  }return DBG_EXCEPTION_NOT_HANDLED;
#endif

  case LOAD_DLL_DEBUG_EVENT: {
//          Char Name[128],Ext[80];
//          FileSplit(DllName,NULL,Name,Ext);
//          StrCat(Name,Ext);
  }
  AddDll((LongWord)Event->u.LoadDll.lpBaseOfDll,DllEntryPoint);
  if (ProcessState >= ps_ProcessComplete) {
   if (IsWin95) {
    if (DllEntryPoint) {
     if (IsWin95 && ((LongWord)Event->u.LoadDll.lpBaseOfDll >= 0x80000000)) ;
     else{
      PatchDllEntry((Pointer)DllEntryPoint);
      SuspendThreads(ThreadHandle);
      if (ProcessState==ps_ProcessComplete) ProcessState=ps_PatchDynamicDll;
     }
    }
   }else{
    Context1.ContextFlags=
#if defined(CPU_INTEL)
			  CONTEXT_FULL | CONTEXT_FLOATING_POINT;
#elif defined(CPU_ALPHA)
			  CONTEXT_FULL;
#endif
    GetThreadContext(ThreadHandle,&Context1);
    if (PatchDlls(ThreadHandle,True,Event->u.LoadDll.lpBaseOfDll))
      ProcessState = ps_PatchDynamicDllNoInit;
   }
  }
  break;

  case UNLOAD_DLL_DEBUG_EVENT: {
   RemoveDll((LongWord)Event->u.UnloadDll.lpBaseOfDll);
  }break;
 }
 return DBG_CONTINUE;
}

Boolean TProcessWatcher::Run(LPCTSTR AppName, LPCTSTR CmdLine,int *ReturnCode) {
 if (!CreateProcess(AppName,(LPTSTR)CmdLine,NULL,NULL,FALSE,
   Inherit ? DEBUG_PROCESS : DEBUG_ONLY_THIS_PROCESS,
   NULL,NULL,&StartupInfo,&ProcessInfo)) return False;
 for (;;) {
  DEBUG_EVENT Event;
  if (WaitForDebugEvent(&Event,INFINITE)) {
   DWORD continueStatus=HandleDebugEvent(&Event);
   if (Event.dwDebugEventCode==EXIT_PROCESS_DEBUG_EVENT 
   && (!Inherit || Event.dwProcessId==FirstProcessId)) {
    *ReturnCode = Event.u.ExitProcess.dwExitCode;
    break;
   }
   ContinueDebugEvent(Event.dwProcessId,Event.dwThreadId,continueStatus);
  }
 }
 return True;
}
////////////////////////////////////////////////////////////////////////////////

BOOL IsWin32(LPCTSTR AppName) {
     // GetBinaryType() wre geeignet, funktioniert aber unter Win95 nicht richtig
 HANDLE f = CreateFile(AppName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
 if (f == INVALID_HANDLE_VALUE) return FALSE;
 BOOL OK=FALSE;
 DWORD D;
 CHAR  Signature[2];
 DWORD Result;
 if (SetFilePointer(f,0x3C,NULL,FILE_BEGIN) 
 &&  ReadFile(f,&D,sizeof D,&Result,NULL)
 &&  D
 &&  SetFilePointer(f,D,NULL,FILE_BEGIN)
 &&  ReadFile(f,Signature,sizeof Signature,&Result,NULL)
 &&  Signature[0]=='P' && Signature[1]=='E') OK=TRUE;
 CloseHandle(f);
 return OK;
}

BOOL WINAPI EnterDateDlgProc(HWND Wnd, UINT Msg, WPARAM wParam, LPARAM lParam) {
// Parameter ist Zeiger auf MYDATE-Struktur
// Macht eine lokal-spezifische(!) Datums- Ein- und Ausgabe
 switch (Msg) {
  case WM_INITDIALOG: {
//   TCHAR buf[64];
   SetWindowLong(Wnd,DWL_USER,lParam);
//   GetDateFormat(0,0,NULL,NULL,buf,elemof(buf));
//   SetDlgItemText(Wnd,102,buf);
  }return TRUE;
  case WM_WININICHANGE: {
   SendDlgItemMessage(Wnd,102,Msg,wParam,lParam); // MSDN sagt: durchreichen!
  }break;
  case WM_COMMAND: switch (LOWORD(wParam)) {
   case IDOK: {
    SYSTEMTIME st;
//    TCHAR buf[64],bf[64];
//    LPTSTR b,p;
//    GetDlgItemText(Wnd,102,buf,elemof(buf));
//    GetLocaleInfo(0,LOCALE_SSHORTDATE,bf,elemof(bf));
    lParam=GetWindowLong(Wnd,DWL_USER);
#define MyDate (*(MYDATE*&)lParam)
    SendDlgItemMessage(Wnd,102,DTM_GETSYSTEMTIME,0,(LPARAM)&st);
    MyDate.day=(BYTE)st.wDay;
    MyDate.month=(BYTE)st.wMonth;
    MyDate.year=st.wYear;
#undef MyDate
   }nobreak;
   case IDCANCEL: EndDialog(Wnd,LOWORD(wParam));
  }
 }
 return FALSE;
}

BOOL GetAppFileName(PChar AppName,int AppNameSize) {
 OPENFILENAME ofn;

 InitStruct(&ofn,sizeof ofn);
 ofn.lpstrFilter=T("Win32-Anwendung (*.exe)\0*.exe\0");
 ofn.lpstrFile  =AppName;
 ofn.nMaxFile   =AppNameSize;
 ofn.lpstrTitle =T("Das Programm fr die \"Zeitmaschine\"");
 ofn.Flags      =OFN_HIDEREADONLY|OFN_FILEMUSTEXIST;
 AppName[0]='\0';
 return GetOpenFileName(&ofn);
}

LPTSTR NextCmdItem(LPTSTR s) {
// Liefert Zeiger auf nchstes Kommandozeilenargument, niemals NULL
// patcht s und entfernt dabei die doppelten Hochkommata
 LPTSTR d=s;
 BOOL InQuote=FALSE;

 while (*s==T(' ') || *s==T('\t')) s++;	// Fhrenden Quell-Weiraum bergehen
 for (;;s++) switch (*s) {		// keine DBCS-Gefahr hier
  case 0: *d=0; return s;		// Zeiger auf die 0
  case T('"'): InQuote=!InQuote; break;	// alle " entfernen, umschalten
  case T(' '):
  case T('\t'): if (!InQuote) {*d=0; return ++s;}	// else nobreak;
  default: *d++=*s;
 }
}

extern "C" int _stdcall WinMainCRTStartup(void) {
 IsWin95 = (Boolean)((GetVersion() & 0xC0000000) == 0xC0000000);
 ghInstance = GetModuleHandle(NULL);
 LPTSTR argv0,argv1,argv2;
 TCHAR AppName[MAX_PATH];

 argv0=GetCommandLine();	// Eigener EXE-Name
 argv1=NextCmdItem(argv0);	// Zu startendes Programm
 argv2=NextCmdItem(argv1);	// Programm-Argumente (Rest der Zeile, unmodifiziert)
 if ((unsigned)FindExecutable(argv1,NULL,AppName)<=32)	// bei Fehler...
   GetFullPathName(argv1,elemof(AppName),AppName,NULL);	// in Puffer und mit Pfad ergnzen
 if (!argv1[0] && !GetAppFileName(AppName,elemof(AppName))) {
  Alert(T("Aufruf: %s <Programmname> [<Arg1> <Arg2>...]\n"),argv0); 
  return 10; 
 }
 if (!IsWin32(AppName)) {
  Alert(T("'%s' ist keine Win32-Anwendung und kann daher nicht berwacht ausgefhrt werden!\n"),AppName); 
  return 13; 
 }
 TCHAR IniName[MAX_PATH];
 GetModuleFileName(0,IniName,elemof(IniName));
 lstrcpy(GetFileNameExt(IniName),T(".ini"));
 Inherit=GetPrivateProfileInt(T("Config"),T("Inherit"),0,IniName);	// undokumentierter Schalter
 MyDate.all=GetPrivateProfileInt(T("Apps"),AppName,0,IniName);
 if (!MyDate.all) {
  INITCOMMONCONTROLSEX icc={sizeof(icc),ICC_DATE_CLASSES};
  InitCommonControlsEx(&icc);
  if (DialogBoxParam(ghInstance,MAKEINTRESOURCE(100),0,EnterDateDlgProc,(LPARAM)&MyDate)!=IDOK) return 10;
  TCHAR buf[16];
  wvsprintf(buf,T("%ld"),(va_list)&MyDate);
  WritePrivateProfileString(T("Apps"),AppName,buf,IniName);
 }
 TCHAR IWatchExtensionDllName[MAX_PATH];
 GetModuleFileName(0,IWatchExtensionDllName,elemof(IWatchExtensionDllName));
 lstrcpy(GetFileNameExt(IWatchExtensionDllName),T(".dll"));

 int ReturnCode = 13;
 PProcessWatcher W = new TProcessWatcher(IWatchExtensionDllName);
 Boolean f = False;
 if (W) {
  f=W->Run(AppName,argv2,&ReturnCode);
  delete W;
 }
 if (!f) {
  Alert(T("Kann Programm '%s' nicht starten, Fehlerkode = %d\n"),AppName,GetLastError());
  return ReturnCode;
 }
 ExitProcess(ReturnCode);	// sonst bleibt das Programm hngen, aber nur, wenn man GetOpenFileName aufrief
 return ReturnCode;
}
